---
title: "Les matrices et tableaux"
weight: 16
output:
  blogdown::html_page:
    toc: false
    fig_width: 6
    dev: "svg"
---

<script src="/rmarkdown-libs/header-attrs/header-attrs.js"></script>


<div id="matrices" class="section level3">
<h3>Matrices</h3>
<ul>
<li>Les matrices sont des collections d’objets de même classe indexés par deux dimensions:</li>
</ul>
<pre class="r"><code>x=matrix(1:9+rnorm(9,sd=.1),nrow=3,ncol=3)
x</code></pre>
<pre><code>##           [,1]     [,2]     [,3]
## [1,] 0.9228736 4.040331 7.005741
## [2,] 1.9716585 4.978351 7.845961
## [3,] 3.1236859 6.087392 8.999346</code></pre>
<ul>
<li>l’indexation se fait via des booléens, des entiers ou des noms lorsque les lignes et colonnes de la matrice en ont.</li>
</ul>
<pre class="r"><code>x[1,1]</code></pre>
<pre><code>## [1] 0.9228736</code></pre>
<pre class="r"><code>x[1,]</code></pre>
<pre><code>## [1] 0.9228736 4.0403311 7.0057415</code></pre>
<pre class="r"><code>x[1:2,]</code></pre>
<pre><code>##           [,1]     [,2]     [,3]
## [1,] 0.9228736 4.040331 7.005741
## [2,] 1.9716585 4.978351 7.845961</code></pre>
<pre class="r"><code>dimnames(x)&lt;-list(letters[1:3],letters[1:3])
x[c(&quot;a&quot;,&quot;c&quot;),c(T,F,T)]</code></pre>
<pre><code>##           a        c
## a 0.9228736 7.005741
## c 3.1236859 8.999346</code></pre>
<p>On peut faire du calcul matriciel :</p>
<pre class="r"><code>t(x)</code></pre>
<pre><code>##           a        b        c
## a 0.9228736 1.971659 3.123686
## b 4.0403311 4.978351 6.087392
## c 7.0057415 7.845961 8.999346</code></pre>
<pre class="r"><code>x%*%t(x)</code></pre>
<pre><code>##          a         b         c
## a 66.25638  76.90055  90.52494
## b 76.90055  90.23053 107.07254
## c 90.52494 107.07254 127.80198</code></pre>
<pre class="r"><code>solve(x)</code></pre>
<pre><code>##           a         b         c
## a  11.38643 -24.18588  12.22212
## b -26.02615  52.24125 -25.28521
## c  13.65252 -26.94239  12.97238</code></pre>
<pre class="r"><code>diag(x)</code></pre>
<pre><code>##         a         b         c 
## 0.9228736 4.9783508 8.9993457</code></pre>
<pre class="r"><code>eigen(x)</code></pre>
<pre><code>## eigen() decomposition
## $values
## [1] 16.13362691 -1.24598658  0.01292981
## 
## $vectors
##            [,1]       [,2]       [,3]
## [1,] -0.4644169 -0.8809858  0.3800294
## [2,] -0.5629418 -0.2370739 -0.8217762
## [3,] -0.6836764  0.4094630  0.4245721</code></pre>
</div>
<div id="tableaux" class="section level3">
<h3>Tableaux</h3>
<p>Les tableaux sont des collections d’objets de même classes indéxées par plusieurs dimensions</p>
<pre class="r"><code>x=array(1:12,dim=c(2,2,3))
x[2,2,2]</code></pre>
<pre><code>## [1] 8</code></pre>
</div>
